SystemOrganization addCategory: #MGPlotting!

Morph subclass: #MGPlotMorph
	instanceVariableNames: 'backgroundColor plotRectangle plotForm coordinatesUnitRectangle relations axisColor extentSharedQueue plotFormSharedQueue plottingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/2/2013 11:02'!
addRelation: aRelation
	relations add: aRelation.
	aRelation addDependent: self.
	self rememberToReplot.
	^ aRelation! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/2/2013 12:00'!
addRelationOn2DBlock: aBlock
	|relation|
	relation := MGRelationOn2DBlock new block: aBlock.
	relations add: relation.
	relation addDependent: self.
	self rememberToReplot.
	^relation! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/2/2013 11:01'!
addRelationOnCollection: aCollection
	|relation|
	relation := MGRelationOnCollection new collection: aCollection.
	relations add: relation.
	relation addDependent: self.
	self rememberToReplot.
	^relation! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/2/2013 11:01'!
addRelationOnCollectionWithIcons: aCollection
	|relation|
	relation := MGRelationOnCollectionWithIcons new collection: aCollection.
	relations add: relation.
	relation addDependent: self.
	self rememberToReplot.
	^relation! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/2/2013 11:01'!
addRelationOnLeftToRightBlock: aBlock
	|relation|
	relation := MGRelationOnLeftToRightBlock new block: aBlock.
	relations add: relation.
	relation addDependent: self.
	self rememberToReplot.
	^relation! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/2/2013 11:01'!
addRelationOnTopToBottomBlock: aBlock
	|relation|
	relation := MGRelationOnTopToBottomBlock new block: aBlock.
	relations add: relation.
	relation addDependent: self.
	self rememberToReplot.
	^relation! !

!MGPlotMorph methodsFor: 'accessing' stamp: 'mg 12/1/2013 13:49'!
axisColor
	^ axisColor! !

!MGPlotMorph methodsFor: 'accessing' stamp: 'mg 12/1/2013 15:47'!
axisColor: aColor
	axisColor := aColor.
	self rememberToReplot.! !

!MGPlotMorph methodsFor: 'accessing' stamp: 'mg 12/1/2013 13:48'!
backgroundColor
	^ backgroundColor! !

!MGPlotMorph methodsFor: 'accessing' stamp: 'mg 12/1/2013 15:47'!
backgroundColor: aColor
	backgroundColor := aColor.
	self rememberToReplot.! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/6/2013 21:27'!
calculateTransformationForExtent: aPoint
	^ MGPlotToFormTransformation 
		plotRectangle: plotRectangle
		formRectangle: (0@0 extent: aPoint).! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 15:45'!
coordinatesOrigin
	^coordinatesUnitRectangle origin! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 15:45'!
coordinatesOrigin: aPoint
	coordinatesUnitRectangle := aPoint extent: (coordinatesUnitRectangle extent).
	self rememberToReplot! !

!MGPlotMorph methodsFor: 'processes' stamp: 'mg 12/6/2013 22:29'!
delete
	super delete.
	plottingProcess terminate! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/1/2013 14:47'!
drawCoordinatesOn: aCanvas transformation: aPlotToFormTransformation
	|transformedCoordinatesUnitRectangle xAxisY yAxisX maxXPoint maxYPoint xUnit yUnit|
	transformedCoordinatesUnitRectangle := aPlotToFormTransformation 
		toFormRectangle: coordinatesUnitRectangle.
	xAxisY := transformedCoordinatesUnitRectangle origin y.
	yAxisX := transformedCoordinatesUnitRectangle origin x.
	maxXPoint := aCanvas extent x @ xAxisY.			
	maxYPoint := yAxisX @ aCanvas extent y.				
	xUnit := transformedCoordinatesUnitRectangle width.		
	yUnit := transformedCoordinatesUnitRectangle height.				
	self 
		drawXAxisOn: aCanvas 
		transformedCoordinatesUnitRectangle: transformedCoordinatesUnitRectangle
		xAxisY: xAxisY 
		yAxisX: yAxisX
		maxXPoint: maxXPoint 
		maxYPoint: maxYPoint
		xUnit: xUnit
		yUnit: yUnit.
	self drawYAxisOn: aCanvas
		transformedCoordinatesUnitRectangle: transformedCoordinatesUnitRectangle
		xAxisY: xAxisY 
		yAxisX: yAxisX
		maxXPoint: maxXPoint 
		maxYPoint: maxYPoint
		xUnit: xUnit
		yUnit: yUnit.
	"coordinatesUnitRectangle origin = (0@0)
	ifTrue:
	[
		aCanvas
			drawString: '0' 
			at: (yAxisX @ xAxisY + (11@ 7)) asIntegerPoint
			font: nil
			color: axisColor.	
	]."! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/6/2013 22:26'!
drawOn: aCanvas
	plotForm ifNotNil: 
	[
		plotForm extent = self extent 
		ifTrue: [aCanvas drawImage: plotForm at: self position]
		ifFalse:
		[
			plotForm := nil. 
			self rememberToReplot.
			aCanvas fillRectangle: self bounds color: backgroundColor 
		].
	]
	ifNil: 
	[
		self rememberToReplot.
		aCanvas fillRectangle: self bounds color: backgroundColor 		
	].! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/1/2013 16:21'!
drawXAxisOn: aCanvas 
transformedCoordinatesUnitRectangle: transformedCoordinatesUnitRectangle
xAxisY: xAxisY 
yAxisX: yAxisX
maxXPoint: maxXPoint 
maxYPoint: maxYPoint
xUnit: xUnit
yUnit: yUnit
	|left right|
	left := coordinatesUnitRectangle origin x.
	right := coordinatesUnitRectangle origin x.
	aCanvas 
		line: (0@ xAxisY) asIntegerPoint
		to: maxXPoint asIntegerPoint
		color: axisColor.
	aCanvas 
		line: maxXPoint asIntegerPoint
		to: (maxXPoint - (10 @ 5)) asIntegerPoint
		color: axisColor.		
	aCanvas 
		line: maxXPoint asIntegerPoint
		to: (maxXPoint - (10 @ -5)) asIntegerPoint
		color: axisColor.
	yAxisX to: maxXPoint x  by: xUnit do:
	[:x|
		aCanvas
			line: (x @ (xAxisY - 5)) asIntegerPoint
			to: (x @ (xAxisY + 5)) asIntegerPoint
			color: axisColor.
		right ~= coordinatesUnitRectangle origin x
		ifTrue:
		[
			aCanvas
				drawString: right asString
				at: (x @ xAxisY + (self xAxisCorrectionForNumber: right)) asIntegerPoint
				font: nil
				color: axisColor.
		].			
		right :=right + coordinatesUnitRectangle width			
	].
	yAxisX to: 0 by: xUnit negated  do:
	[:x|
		aCanvas
			line: (x @ (xAxisY - 5)) asIntegerPoint
			to: (x @ (xAxisY + 5)) asIntegerPoint
			color: axisColor.
		left ~= coordinatesUnitRectangle origin x
		ifTrue:
		[
			aCanvas
				drawString: left asString
				at: (x @ xAxisY + (self xAxisCorrectionForNumber: left)) asIntegerPoint
				font: nil
				color: axisColor.
		].
		left :=left - coordinatesUnitRectangle width	
	].! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/1/2013 16:22'!
drawYAxisOn: aCanvas 
transformedCoordinatesUnitRectangle: transformedCoordinatesUnitRectangle
xAxisY: xAxisY 
yAxisX: yAxisX
maxXPoint: maxXPoint 
maxYPoint: maxYPoint
xUnit: xUnit
yUnit: yUnit
	|top bottom|
	top := coordinatesUnitRectangle origin y.
	bottom := coordinatesUnitRectangle origin y.
	aCanvas 
		line: (yAxisX @ 0) asIntegerPoint
		to: (yAxisX @ aCanvas extent y) asIntegerPoint
		color: axisColor.
	aCanvas 
		line: (yAxisX @ 0) asIntegerPoint
		to: (yAxisX @ 0 + (5 @ 10)) asIntegerPoint
		color: axisColor.
	aCanvas
		line: (yAxisX @ 0) asIntegerPoint
		to: (yAxisX @ 0 + (-5 @ 10)) asIntegerPoint
		color: axisColor.
	xAxisY to: maxYPoint y  by: yUnit negated do:
	[:y|
		aCanvas
			line: ((yAxisX - 5) @ y) asIntegerPoint
			to: ((yAxisX + 5)  @ y) asIntegerPoint
			color: axisColor.
		bottom ~= coordinatesUnitRectangle origin y
		ifTrue:
		[
			aCanvas
				drawString: bottom asString
				at: (yAxisX @ y +(self yAxisCorrectionForNumber: bottom)) asIntegerPoint
				font: nil
				color: axisColor.
		].
		bottom :=bottom - coordinatesUnitRectangle height
	].
	xAxisY to: 0 by: yUnit do:
	[:y|
		aCanvas
			line: ((yAxisX - 5) @ y) asIntegerPoint
			to: ((yAxisX + 5)  @ y) asIntegerPoint
			color: axisColor.
		top ~= coordinatesUnitRectangle origin y
		ifTrue:
		[
			aCanvas
				drawString: top asString
				at: (yAxisX @ y +(self yAxisCorrectionForNumber: top)) asIntegerPoint
				font: nil
				color: axisColor.
		].			
		top :=top + coordinatesUnitRectangle height
	].		! !

!MGPlotMorph methodsFor: 'initialize-release' stamp: 'mg 12/6/2013 21:54'!
initialize
	super initialize.
	self extent: 400@400.
	plotRectangle := -10@ -10 corner: 10@10.
	coordinatesUnitRectangle := 0@0  corner: 1@1.
	relations := OrderedCollection new.
	backgroundColor := Color white.
	axisColor := Color black.
	extentSharedQueue := SharedQueue2 new.
	plotFormSharedQueue := SharedQueue2 new.
	plottingProcess := [self plottingLoop] fork! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 13:26'!
maxX
	^ plotRectangle right! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 16:09'!
maxX: aNumber
	plotRectangle := plotRectangle right: aNumber.
	self rememberToReplot.! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 13:35'!
maxY
	^ plotRectangle top negated! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 16:09'!
maxY: aNumber
	plotRectangle := plotRectangle top: aNumber negated.
	self rememberToReplot.	! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 13:26'!
minX
	^ plotRectangle left! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 16:09'!
minX: aNumber
	plotRectangle := plotRectangle left: aNumber.
	self rememberToReplot.	! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 13:35'!
minY
	^ plotRectangle bottom negated! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 16:09'!
minY: aNumber
	plotRectangle := plotRectangle bottom: aNumber negated.
	self rememberToReplot.	! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/6/2013 22:16'!
newFormForExtent: aPoint
	|canvas transform newPlotForm|
	newPlotForm := Form extent: aPoint depth: 32.
	newPlotForm fillColor: backgroundColor.
	canvas := newPlotForm getCanvas.
	transform := self calculateTransformationForExtent: aPoint.
	relations do:
	[:relation|
		relation drawOn: canvas transformation: transform.
	].
	self drawCoordinatesOn: canvas transformation: transform.
	^ newPlotForm.
	
	
	! !

!MGPlotMorph methodsFor: 'processes' stamp: 'mg 12/6/2013 22:10'!
plottingLoop
	|extent|
	[
		extent := extentSharedQueue nextOrNil.
		extent ifNotNil:
		[
			plotFormSharedQueue nextPut: (self newFormForExtent: extent)
		].
		plottingProcess suspend
	] repeat.! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/1/2013 15:50'!
relations
	^relations asArray! !

!MGPlotMorph methodsFor: 'accessing' stamp: 'mg 12/1/2013 13:23'!
relations: aCollection
	relations := aCollection.! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/6/2013 21:59'!
rememberToReplot
	extentSharedQueue isEmpty ifTrue: [extentSharedQueue nextPut: self extent].
	
	! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/1/2013 15:59'!
removeAllRelations
	relations do:
	[:relation|
		relation removeDependent: self
	].
	relations removeAll.
	self rememberToReplot.! !

!MGPlotMorph methodsFor: 'relations' stamp: 'mg 12/1/2013 15:59'!
removeRelation: aRelation
	relations remove: aRelation.
	aRelation removeDependent: self.
	self rememberToReplot.! !

!MGPlotMorph methodsFor: 'processes' stamp: 'mg 12/6/2013 22:13'!
step
	plotFormSharedQueue isEmpty
	ifFalse:
	[
		[plotFormSharedQueue isEmpty] 
		whileFalse:
		[plotForm := plotFormSharedQueue next].
		self changed
	].
	plottingProcess resume! !

!MGPlotMorph methodsFor: 'processes' stamp: 'mg 12/6/2013 22:38'!
stepTime
	^500! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 15:47'!
units
	^ coordinatesUnitRectangle extent.! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 16:07'!
units: aPoint
	coordinatesUnitRectangle := coordinatesUnitRectangle origin extent: aPoint.
	self rememberToReplot.! !

!MGPlotMorph methodsFor: 'updating' stamp: 'mg 12/1/2013 16:02'!
update: aParameter
	self rememberToReplot! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/1/2013 16:19'!
xAxisCorrectionForNumber: aNumber
	aNumber negative
	ifTrue:
	[
		^(-6 @ 7)
	]
	ifFalse:
	[
		^( -2 @ 7)
	]! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 15:39'!
xUnit
	^coordinatesUnitRectangle width! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 16:13'!
xUnit: aNumber
	coordinatesUnitRectangle := coordinatesUnitRectangle origin 
		extent: aNumber @ coordinatesUnitRectangle extent y.
	self rememberToReplot.! !

!MGPlotMorph methodsFor: 'drawing' stamp: 'mg 12/1/2013 16:20'!
yAxisCorrectionForNumber: aNumber
	aNumber negative
	ifTrue:
	[
		^(8 @ -6)
	]
	ifFalse:
	[
		^(11 @ -6)
	]! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 15:39'!
yUnit
	^coordinatesUnitRectangle height! !

!MGPlotMorph methodsFor: 'coordinate system' stamp: 'mg 12/1/2013 16:14'!
yUnit: aNumber
	coordinatesUnitRectangle := coordinatesUnitRectangle origin 
		extent: coordinatesUnitRectangle extent x @ aNumber.
	self rememberToReplot.! !

Object subclass: #MGPlotToFormTransformation
	instanceVariableNames: 'toPlotMatrix toFormMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGPlotToFormTransformation class methodsFor: 'instance creation' stamp: 'mg 12/1/2013 02:09'!
plotRectangle: plotRectangle formRectangle: formRectangle
	^ self new plotRectangle: plotRectangle formRectangle: formRectangle! !

!MGPlotToFormTransformation methodsFor: 'initialize-release' stamp: 'mg 12/1/2013 02:07'!
calculateToFormMatrixUsingPlotRectangle: plotRectangle formRectangle: formRectangle
	|pm0 pm1 pm2 pm3|
	pm0 := Matrix
		rows: 3 
		columns: 3 
		contents:
		{
			1.  0. 0.
			0. -1. 0.
			0.  0. 1
		}.
	pm1 := Matrix 
		rows: 3 
		columns: 3 
		contents:
		{
			1. 0. plotRectangle origin x negated.
			0. 1. plotRectangle origin y negated.
			0. 0. 1
		}.
	pm2 := Matrix 
		rows: 3 
		columns: 3 
		contents:
		{
			(formRectangle corner x - formRectangle origin x) 
			/ (plotRectangle corner x - plotRectangle origin x). 0. 0.
			0. (formRectangle corner y - formRectangle origin y) 
			/ (plotRectangle corner y - plotRectangle origin y). 0.
			0. 0. 1
		}.		
	pm3 := Matrix 
		rows: 3 
		columns: 3 
		contents:
		{
			1. 0. formRectangle origin x.
			0. 1. formRectangle origin y.
			0. 0. 1
		}.
	toFormMatrix := (pm3 +* pm2 +*  pm1 +* pm0) atRows: 1 to: 2 columns: 1 to: 3.! !

!MGPlotToFormTransformation methodsFor: 'initialize-release' stamp: 'mg 12/1/2013 02:05'!
calculateToPlotMatrixUsingPlotRectangle: plotRectangle formRectangle: formRectangle
	|mp0 mp1 mp2 mp3|
	mp0 := Matrix
		rows: 3 
		columns: 3 
		contents:
		{
			1.  0. 0.
			0. -1. 0.
			0.  0. 1
		}.
	mp1 := Matrix 
		rows: 3 
		columns: 3 
		contents:
		{
			1. 0. formRectangle origin x negated.
			0. 1. formRectangle origin y negated.
			0. 0. 1
		}.
	mp2 := Matrix 
		rows: 3 
		columns: 3 
		contents:
		{
			(plotRectangle corner x - plotRectangle origin x) 
			/ (formRectangle corner x - formRectangle origin x). 0. 0.
			0. (plotRectangle corner y - plotRectangle origin y) 
			/ (formRectangle corner y - formRectangle origin y). 0.
			0. 0. 1
		}.		
	mp3 := Matrix 
		rows: 3 
		columns: 3 
		contents:
		{
			1. 0. plotRectangle origin x.
			0. 1. plotRectangle origin y.
			0. 0. 1
		}.
	toPlotMatrix := (mp0 +* mp3 +* mp2 +*  mp1) atRows: 1 to: 2 columns: 1 to: 3.! !

!MGPlotToFormTransformation methodsFor: 'initialize-release' stamp: 'mg 12/1/2013 02:08'!
plotRectangle: plotRectangle formRectangle: formRectangle
	self calculateToFormMatrixUsingPlotRectangle: plotRectangle formRectangle: formRectangle.
	self calculateToPlotMatrixUsingPlotRectangle: plotRectangle formRectangle: formRectangle.	
! !

!MGPlotToFormTransformation methodsFor: 'transformation' stamp: 'mg 12/1/2013 02:06'!
toFormPoint: aPoint
	|array|
	array := toFormMatrix +* {aPoint x. aPoint y. 1}.
	^ array first @ array last! !

!MGPlotToFormTransformation methodsFor: 'transformation' stamp: 'mg 12/1/2013 02:06'!
toFormPoints: aCollection
	^aCollection collect: [:aPoint| self toFormPoint: aPoint].! !

!MGPlotToFormTransformation methodsFor: 'transformation' stamp: 'mg 12/1/2013 02:06'!
toFormRectangle: aRectangle 
	^(self toFormPoint: aRectangle origin) corner: (self toFormPoint: aRectangle corner)! !

!MGPlotToFormTransformation methodsFor: 'transformation' stamp: 'mg 12/1/2013 01:17'!
toPlotPoint: aPoint
	|array|
	array := toPlotMatrix +* {aPoint x. aPoint y. 1}.
	^ array first @ array last! !

!MGPlotToFormTransformation methodsFor: 'transformation' stamp: 'mg 12/1/2013 01:14'!
toPlotPoints: aCollection
	^aCollection collect: [:aPoint| self toPlotPoint: aPoint].! !

!MGPlotToFormTransformation methodsFor: 'transformation' stamp: 'mg 12/1/2013 01:13'!
toPlotRectangle: aRectangle
	^(self toPlotPoint: aRectangle origin) corner: (self toPlotPoint: aRectangle corner)! !

Object subclass: #MGPoint
	instanceVariableNames: 'point pointIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:27'!
bigCrossPoint: aPoint
	^self new point: aPoint; pointIcon: MGCrossPointIcon big! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:29'!
bigCrossPoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGCrossPointIcon bigWithColor: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:27'!
bigRectanglePoint: aPoint
	^self new point: aPoint; pointIcon: MGRectanglePointIcon big! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:29'!
bigRectanglePoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGRectanglePointIcon bigWithColor: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:24'!
crossPoint: aPoint
	^self new point: aPoint; pointIcon: MGCrossPointIcon new! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 10:51'!
crossPoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGCrossPointIcon color: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:30'!
crossPoint: aPoint1 color: aColor extent: aPoint2
	^self new point: aPoint1; pointIcon: (MGCrossPointIcon color: aColor extent: aPoint2)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:37'!
crossPoint: aPoint1 extent: aPoint2
	^self new point: aPoint1; pointIcon: (MGCrossPointIcon extent: aPoint2)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:24'!
dotPoint: aPoint
	^self new point: aPoint; pointIcon: MGDotPointIcon new! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 10:51'!
dotPoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGDotPointIcon color: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:26'!
dotPoint: aPoint1 color: aColor extent: aPoint2
	^self new point: aPoint1; pointIcon: (MGDotPointIcon color: aColor; extent: aPoint2)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:27'!
mediumCrossPoint: aPoint
	^self new point: aPoint; pointIcon: MGCrossPointIcon medium! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:28'!
mediumCrossPoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGCrossPointIcon mediumWithColor: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:26'!
mediumRectanglePoint: aPoint
	^self new point: aPoint; pointIcon: MGRectanglePointIcon medium! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:29'!
mediumRectanglePoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGRectanglePointIcon mediumWithColor: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 10:43'!
point: aPoint pointIcon: aPointIcon
	^self new point: aPoint; pointIcon: aPointIcon ! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:24'!
rectanglePoint: aPoint
	^self new point: aPoint; pointIcon: MGRectanglePointIcon new! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:13'!
rectanglePoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGRectanglePointIcon color: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:30'!
rectanglePoint: aPoint1 color: aColor extent: aPoint2
	^self new point: aPoint1; pointIcon: (MGRectanglePointIcon color: aColor extent: aPoint2)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:37'!
rectanglePoint: aPoint1 extent: aPoint2
	^self new point: aPoint1; pointIcon: (MGRectanglePointIcon extent: aPoint2)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:27'!
smallCrossPoint: aPoint
	^self new point: aPoint; pointIcon: MGCrossPointIcon small! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:28'!
smallCrossPoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGCrossPointIcon smallWithColor: aColor)! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:26'!
smallRectanglePoint: aPoint
	^self new point: aPoint; pointIcon: MGRectanglePointIcon small! !

!MGPoint class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:29'!
smallRectanglePoint: aPoint color: aColor
	^self new point: aPoint; pointIcon: (MGRectanglePointIcon smallWithColor: aColor)! !

!MGPoint methodsFor: 'accessing' stamp: 'mg 12/2/2013 10:43'!
point

	^ point! !

!MGPoint methodsFor: 'accessing' stamp: 'mg 12/2/2013 10:43'!
point: anObject

	point := anObject! !

!MGPoint methodsFor: 'accessing' stamp: 'mg 12/2/2013 10:43'!
pointIcon

	^ pointIcon! !

!MGPoint methodsFor: 'accessing' stamp: 'mg 12/2/2013 10:43'!
pointIcon: anObject

	pointIcon := anObject! !

Object subclass: #MGPointIcon
	instanceVariableNames: 'color extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

MGPointIcon subclass: #MGCrossPointIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGCrossPointIcon methodsFor: 'drawing' stamp: 'mg 12/2/2013 11:23'!
drawOn: aCanvas at: aPoint
	aCanvas
		line: (aPoint - (extent / 2)) asIntegerPoint
		to: (aPoint + (extent / 2)) asIntegerPoint
		color: color.
	aCanvas
		line: (aPoint - (extent leftRotated / 2)) asIntegerPoint
		to: (aPoint + (extent leftRotated / 2)) asIntegerPoint
		color: color.		! !

MGPointIcon subclass: #MGDotPointIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGDotPointIcon methodsFor: 'drawing' stamp: 'mg 12/1/2013 15:10'!
drawOn: aCanvas at: aPoint
	aCanvas
		point: aPoint asIntegerPoint
		color: color! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:28'!
big
	^ self new extent: 8@8! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:28'!
bigWithColor: aColor
	^ self new extent: 8@8; color: aColor! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/1/2013 15:09'!
color: aColor
	^ self new color: aColor! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:17'!
color: aColor extent: aPoint
	^ self new color: aColor; extent: aPoint! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:17'!
extent: aPoint
	^ self new extent: aPoint! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:20'!
medium
	^ self new extent: 4@4! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:19'!
mediumWithColor: aColor
	^ self new extent: 4@4; color: aColor! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:20'!
small
	^ self new extent: 1@1! !

!MGPointIcon class methodsFor: 'instance creation' stamp: 'mg 12/2/2013 11:35'!
smallWithColor: aColor
	^ self new extent: 2@2; color: aColor! !

!MGPointIcon methodsFor: 'accessing' stamp: 'mg 12/1/2013 15:09'!
color
	^ color ! !

!MGPointIcon methodsFor: 'accessing' stamp: 'mg 12/1/2013 15:10'!
color: aColor
	color := aColor! !

!MGPointIcon methodsFor: 'drawing' stamp: 'mg 12/1/2013 15:02'!
drawOn: aCanvas at: aPoint
	self subclassResponsibility! !

!MGPointIcon methodsFor: 'accessing' stamp: 'mg 12/2/2013 11:16'!
extent
	^ extent! !

!MGPointIcon methodsFor: 'accessing' stamp: 'mg 12/2/2013 11:16'!
extent: aPoint
	extent := aPoint! !

!MGPointIcon methodsFor: 'initialize-release' stamp: 'mg 12/2/2013 11:17'!
initialize
	super initialize.
	color := Color black.
	extent := 1@1.! !

MGPointIcon subclass: #MGRectanglePointIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRectanglePointIcon methodsFor: 'drawing' stamp: 'mg 12/2/2013 11:45'!
drawOn: aCanvas at: aPoint
	aCanvas fillRectangle: (Rectangle center: aPoint asIntegerPoint extent: extent asIntegerPoint) color: color.! !

Object subclass: #MGRelation
	instanceVariableNames: 'plotColor isContinuous pointIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRelation methodsFor: 'accessing' stamp: 'mg 12/1/2013 16:01'!
continuous
	isContinuous := true.
	self changed.! !

!MGRelation methodsFor: 'drawing' stamp: 'mg 12/1/2013 02:53'!
drawOn: aCanvas transformation: aPlotToFormTransformation
	isContinuous 
	ifTrue:
	[
		self drawContinuousOn: aCanvas transformation: aPlotToFormTransformation
	]
	ifFalse:
	[
		self drawNotContinuousOn: aCanvas transformation: aPlotToFormTransformation	
	]! !

!MGRelation methodsFor: 'initialize-release' stamp: 'mg 12/2/2013 10:41'!
initialize
	super initialize.
	plotColor := Color black.
	isContinuous := false.
	pointIcon := MGDotPointIcon color: plotColor.! !

!MGRelation methodsFor: 'testing' stamp: 'mg 12/1/2013 16:01'!
isContinuous
	^ isContinuous! !

!MGRelation methodsFor: 'accessing' stamp: 'mg 12/1/2013 16:00'!
notContinuous
	isContinuous := false.
	self changed.! !

!MGRelation methodsFor: 'accessing' stamp: 'mg 12/1/2013 02:43'!
plotColor
	^plotColor! !

!MGRelation methodsFor: 'accessing' stamp: 'mg 12/2/2013 10:40'!
plotColor: aColor
	plotColor := aColor.
	pointIcon color: aColor.
	self changed! !

!MGRelation methodsFor: 'accessing' stamp: 'mg 12/2/2013 10:39'!
pointIcon
	^ pointIcon! !

!MGRelation methodsFor: 'accessing' stamp: 'mg 12/2/2013 10:40'!
pointIcon: aPointIcon
	pointIcon := aPointIcon.
	self changed.! !

MGRelation subclass: #MGRelationOnBlock
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

MGRelationOnBlock subclass: #MGRelationOn1DBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRelationOn1DBlock methodsFor: 'initialize-release' stamp: 'mg 12/2/2013 11:52'!
initialize
	super initialize.
	block := [:a|a].! !

!MGRelationOn1DBlock methodsFor: 'calculating block values' stamp: 'mg 12/2/2013 11:51'!
valuesFor: anObject
		|values|
		values := block value: anObject.
		true caseOf:
		{
			[values isNil] -> [^{}].
			[values isCollection] -> [^values]
		}
		otherwise: [^{values}].
		! !

MGRelationOn1DBlock subclass: #MGRelationOnLeftToRightBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRelationOnLeftToRightBlock methodsFor: 'drawing' stamp: 'mg 12/2/2013 12:04'!
drawContinuousOn: aCanvas transformation: aPlotToFormTransformation
	|xValue currentValues previousValues|
	previousValues := (self valuesFor: ((aPlotToFormTransformation toPlotPoint: 0 @ 0) x)).
	
	1 to: aCanvas extent x do:
	[:xVal|
		xValue := (aPlotToFormTransformation toPlotPoint: xVal @ 0) x.
		currentValues := self valuesFor: xValue.
		currentValues with: previousValues do:
		[:currentYValue :previousYValue|
			aCanvas
				line: (aPlotToFormTransformation toFormPoint: xValue @ previousYValue) asIntegerPoint
				to: (aPlotToFormTransformation toFormPoint: xValue @ currentYValue) asIntegerPoint
				color: plotColor.
		].
		previousValues := currentValues.
	]! !

!MGRelationOnLeftToRightBlock methodsFor: 'drawing' stamp: 'mg 12/2/2013 12:04'!
drawNotContinuousOn: aCanvas transformation: aPlotToFormTransformation
	|xValue|
	0 to: aCanvas extent x do:
	[:xVal|
		xValue := (aPlotToFormTransformation toPlotPoint: xVal @ 0) x.
		(self valuesFor: xValue) do:
		[:yValue|
			pointIcon 
				drawOn: aCanvas
				at: (aPlotToFormTransformation toFormPoint: xValue @ yValue)
		]
	]! !

MGRelationOn1DBlock subclass: #MGRelationOnTopToBottomBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRelationOnTopToBottomBlock methodsFor: 'drawing' stamp: 'mg 12/2/2013 12:04'!
drawContinuousOn: aCanvas transformation: aPlotToFormTransformation
	|yValue currentValues previousValues|
	previousValues := (self valuesFor: ((aPlotToFormTransformation toPlotPoint: 0 @ 0) y)).
	
	1 to: aCanvas extent y do:
	[:yVal|
		yValue := (aPlotToFormTransformation toPlotPoint: 0 @ yVal) y.
		currentValues := self valuesFor: yValue.
		currentValues with: previousValues do:
		[:currentXValue :previousXValue|
			aCanvas
				line: (aPlotToFormTransformation toFormPoint: previousXValue @ yValue) asIntegerPoint
				to: (aPlotToFormTransformation toFormPoint: currentXValue @ yValue) asIntegerPoint
				color: plotColor.		
		]
	]! !

!MGRelationOnTopToBottomBlock methodsFor: 'drawing' stamp: 'mg 12/2/2013 12:03'!
drawNotContinuousOn: aCanvas transformation: aPlotToFormTransformation
	|yValue|
	0 to: aCanvas extent y do:
	[:yVal|
		yValue := (aPlotToFormTransformation toPlotPoint: 0 @ yVal) y.
		(self valuesFor: yValue) do:
		[:xValue|
			pointIcon 
				drawOn: aCanvas
				at: (aPlotToFormTransformation toFormPoint: xValue @ yValue)
		]
	]! !

MGRelationOnBlock subclass: #MGRelationOn2DBlock
	instanceVariableNames: 'minimalStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRelationOn2DBlock methodsFor: 'drawing' stamp: 'mg 12/6/2013 20:12'!
drawOn: aCanvas transformation: aPlotToFormTransformation
	|formXStep formYStep value zeroPoint zeroPointX zeroPointY xVersor yVersor xVersorX xVersorY yVersorX yVersorY|
	"Z optymalizacjami"
	formXStep := 1.
	formYStep := 1.
	zeroPoint := aPlotToFormTransformation toPlotPoint: 0@0.
	xVersor := (aPlotToFormTransformation toPlotPoint: 1@0) - zeroPoint.
	yVersor := (aPlotToFormTransformation toPlotPoint: 0@1) - zeroPoint.
	xVersor r < minimalStep
	ifTrue: 
	[	
		formXStep := (
			aPlotToFormTransformation 
				toFormPoint: zeroPoint + (xVersor normalized * minimalStep)
		) r ceiling.			
	].
	yVersor r < minimalStep
	ifTrue: 
	[			
		formYStep := (
			aPlotToFormTransformation 
				toFormPoint: zeroPoint + (yVersor normalized * minimalStep)
		) r ceiling.			
	].
	
	xVersorX := xVersor x.
	xVersorY := xVersor y.	
	zeroPointX := zeroPoint x.
	zeroPointY := zeroPoint y.	
	yVersorX := yVersor x.
	yVersorY := yVersor y.	
	0 to: aCanvas extent x  by: formXStep do:
	[:x|
		0 to: aCanvas extent y by: formYStep do:
		[:y||xSrodka ySrodka|
			xSrodka := x + (formXStep // 2).
			ySrodka := y + (formYStep // 2).
			value := block 
				value: zeroPointX + (xSrodka*xVersorX) + (ySrodka*yVersorX)
				value: zeroPointY + (xSrodka*xVersorY) + (ySrodka*yVersorY).
			aCanvas
				fillRectangle:
				(x@y extent: formXStep @ formYStep)
				color: (Color white alphaMixed: value with: plotColor).
		]
	]! !

!MGRelationOn2DBlock methodsFor: 'initialize-release' stamp: 'mg 12/6/2013 20:02'!
initialize
	super initialize.
	block := [:aPoint|Color transparent].
	minimalStep := 0.! !

!MGRelationOn2DBlock methodsFor: 'accessing' stamp: 'mg 12/6/2013 18:30'!
minimalStep

	^ minimalStep! !

!MGRelationOn2DBlock methodsFor: 'accessing' stamp: 'mg 12/6/2013 20:52'!
minimalStep: anObject

	minimalStep := anObject.
	self changed.
	! !

!MGRelationOnBlock methodsFor: 'accessing' stamp: 'mg 11/30/2013 23:39'!
block
	^block! !

!MGRelationOnBlock methodsFor: 'accessing' stamp: 'mg 12/1/2013 16:02'!
block: aBlock
	block := aBlock.
	self changed.! !

MGRelation subclass: #MGRelationOnCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRelationOnCollection methodsFor: 'accessing' stamp: 'mg 11/30/2013 23:38'!
collection
	^ collection! !

!MGRelationOnCollection methodsFor: 'accessing' stamp: 'mg 12/1/2013 16:01'!
collection: aCollection
	collection := aCollection.
	self changed.! !

!MGRelationOnCollection methodsFor: 'drawing' stamp: 'mg 12/1/2013 13:37'!
drawContinuousOn: aCanvas transformation: aPlotToFormTransformation
	collection overlappingPairsDo:
	[:firstPoint :secondPoint|
		aCanvas 
			line: (aPlotToFormTransformation toFormPoint: firstPoint) asIntegerPoint
			to: (aPlotToFormTransformation toFormPoint: secondPoint) asIntegerPoint
			color: plotColor
	]! !

!MGRelationOnCollection methodsFor: 'drawing' stamp: 'mg 12/2/2013 10:41'!
drawNotContinuousOn: aCanvas transformation: aPlotToFormTransformation
	collection do:
	[:point||transformedPoint|
		transformedPoint := (aPlotToFormTransformation toFormPoint: point).
		pointIcon drawOn: aCanvas at: transformedPoint.
	]! !

!MGRelationOnCollection methodsFor: 'initialize-release' stamp: 'mg 12/2/2013 10:48'!
initialize
	super initialize.
	collection := OrderedCollection new.! !

MGRelationOnCollection subclass: #MGRelationOnCollectionWithIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MGPlotting'!

!MGRelationOnCollectionWithIcons methodsFor: 'drawing' stamp: 'mg 12/2/2013 10:49'!
drawContinuousOn: aCanvas transformation: aPlotToFormTransformation
	collection overlappingPairsDo:
	[:firstPoint :secondPoint|
		aCanvas 
			line: (aPlotToFormTransformation toFormPoint: firstPoint point) asIntegerPoint
			to: (aPlotToFormTransformation toFormPoint: secondPoint point) asIntegerPoint
			color: plotColor
	]! !

!MGRelationOnCollectionWithIcons methodsFor: 'drawing' stamp: 'mg 12/2/2013 10:50'!
drawNotContinuousOn: aCanvas transformation: aPlotToFormTransformation
	collection do:
	[:point||transformedPoint|
		transformedPoint := (aPlotToFormTransformation toFormPoint: point point).
		point pointIcon drawOn: aCanvas at: transformedPoint.
	]! !
